#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_


import win32api as wa
import win32con as wc
import win32ui as wu
import win32gui as wg

import os

import reg, _winreg
from render_image import renderImage


##################
## Fond d'cran ##
##################
def set_backgrnd(sid, message):
    """<message> est une liste, crit 1 item par ligne
    en haut  droite sur le fond d'cran de <sid>
    """
    bgkey = r'%s\Control Panel\Desktop'%sid
    bg = reg.get_option(bgkey, 'Wallpaper', _winreg.HKEY_USERS)
    outbg = os.path.join(wa.GetTempPath(), 'cliscribe_bg.bmp')
    renderImage(bg, outbg, get_format(sid), message, get_backgrnd_color(), get_resolution())
    return reg.addreg(_winreg.HKEY_USERS, bgkey, _winreg.REG_SZ, 'Wallpaper', outbg)

def get_resolution():
    """renvoie la rsolution de l'affichage
    """
    hor = wu.GetDeviceCaps(wg.GetDC(0), wc.HORZRES)
    ver = wu.GetDeviceCaps(wg.GetDC(0), wc.VERTRES)
    return (hor, ver)

def get_backgrnd_color():
    """Retourne le code couleur du fond sans image
    """
    bgc = hex(wa.GetSysColor(wc.COLOR_DESKTOP))[2:]
    return '#%s%s%s'%(bgc[4:6], bgc[2:4], bgc[0:2])

def get_format(sid):
    """retourne le mode d'affiche du BG
    """
    bgkey = r'%s\Control Panel\Desktop'%sid
    style = reg.get_option(bgkey, 'WallpaperStyle', _winreg.HKEY_USERS)
    tile = reg.get_option(bgkey, 'TileWallpaper', _winreg.HKEY_USERS)
    if tile == '1': return "mosaique"
    if style == '0': return "centre"
    return "etendre"
