# _*_ coding: iso-8859-1 _*_
#!/usr/bin/env python

from logging import info, error

from reg import put_regs, clean_user_reg, clean_machine_reg, get_option
from lance_cmd import lancecmd
from perms import AjouterPrivilege

import win32api as wa
import win32con as wc
import os
import reg, background


"""
Par le service :
- registre (nettoyage, nouvelles rgles)
- dconnexion
- synchro horaire
- privilege
- ACLs fichier / registre

Par l'utilisateur :
- fond d'cran
- imprimantes
- ini
- js
"""


def logon(logon_dict, inst_path, nom_scribe):
    applique_registre(logon_dict)
    timesync(inst_path)
    privilege(logon_dict, nom_scribe)
    
def applique_registre(logon_dict):
    info('Application de cls de registre machine')
    clean_machine_reg()
    put_regs(logon_dict['regedit_machine'])
    info('Cls de registre machine appliquees')
    if logoff(): return
    info('Application de cls de registre utilisateur')
    clean_user_reg()
    put_regs(logon_dict['regedit_user'])
    info('Cls de registre utilisateur appliquees')

def logoff():
    if get_option(r'SOFTWARE\CRDP Bretagne\ESU', 'DisconnectBadUsers') == '1':
        info("Deconnexion de l'utilisateur")
        opts = wc.EWX_LOGOFF | wc.EWX_FORCE
        wa.ExitWindowsEx(opts,0)
        return True
    return False

def timesync(inst_path):
    time_server = get_option(r'SOFTWARE\CRDP Bretagne\ESU', 'TimeServer')
    if time_server:
        info('Synchornisation horaire sur "%s"'%time_server)
        cmd = os.path.join(inst_path, 'esuNtpC.exe')
        wa.WinExec('%s /h:%s'%(cmd, time_server))

def privilege(logon_dict, nom_scribe):
    username = logon_dict['username']
    for priv, value in logon_dict['privilege']:
        if value == 'ADD':
            info('Application du privilege "%s"'%privilege)
            AjouterPrivilege(username, privilege, nom_scribe)


def put_acl(logon_dict):
    info("Application d'ACLs")
    pass