# _*_ coding: iso-8859-1 _*_

from twisted.internet import threads
from twisted.internet import reactor

import _winreg

import os
import sys
import shutil
import time
import logging
import subprocess
import urllib2, md5

import win32api as wa

from logging.handlers import RotatingFileHandler
from platform import release

from parse import get_option
from messagebox import gmessage
from lance_cmd import lancecmd


class upDater:
    def __init__(self, restart=True):
        """
        fichier de configuration "install.ini" (contient la version du client)
        setup  tlcharger "cliscribe-setup.exe" (/ip_scribe=... /nom_scribe=... /nom_domaine=...)
        self.inst_path: chemin d'installation des applications
        self.tmpdir: rpertoire de tlchargement/dcompactage
        """
        # cration du logger
        self.set_logger()
        # redmarrer auto en fin d'install ?
        self.restart = restart
        # type de l'OS
        self.type_os = release().lower()
        if self.type_os in ['xp', '2000']:
            self.type_os = 'xp'
        elif self.type_os in ['95', '98', 'me']:
            self.type_os = '9x'
        # chargement des valeurs depuis la BDR
        self.get_values()
        # nom du fichier  tlcharger
        self.setup = 'cliscribe-setup.exe'
        # le rpertoire temporaire pour le tlchargement
        self.tmpdir = os.path.join(self.inst_path, 'tmp')
        # fichier de configuration
        self.conf_f_name = 'install.ini'
        self.conf_f = os.path.join(self.inst_path, self.conf_f_name)
        self.get_version()

    def get_values(self):
        # adresse ip scribe et port du serveur de fichiers
##        self.inst_args = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'inst_args')
        self.serveur = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'ip_scribe')
        self.port = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'port_scribe_update')
        # rcupration des valeurs  passer en argument
        self.inst_path = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'inst_path')
##        self.nom_scribe = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'nom_scribe')
##        self.port_scribe = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'port_scribe')
##        self.nom_domaine = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'nom_domaine')
##        self.port_client = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Eole\Scribe', 'port_client')

    def get_version(self):
        # rcupration du numro de version local
        self.cur_ver = int(get_option(self.conf_f, 'global', 'version'))

    #################
    ## Mise  jour ##
    #################
    def test_update(self):
        """compare le numro de version local et distant (tlchargement de self.serveur/install.ini)
        si local infrieur  distant, lance la mise  jour
        """
        # version = 0 sur la station permet de dsactiver la MAJ du client Scribe
        if self.cur_ver == 0:
            self.log.info("Mise a jour desactivee sur cette machine (Version locale = 0)")
            return True
        if not self.inst_path:
            self.log.error(u'Cle de registre "inst_path" non trouvee, Abandon !')
            return False
        # tlchargement de http://<scribe>/install.ini
        conf_f = self.download(self.conf_f_name)
        if not conf_f: return False
        # rcupration du numro de version distant
        self.new_ver = int(get_option(conf_f, 'global', 'version'))
        self.log.info('Test de version => current : %s, new : %s'%(self.cur_ver, self.new_ver))
        self.old_ver = self.cur_ver
        # version = 0 sur le serveur permet de dsactiver la MAJ du client Scribe sur toutes les stations
        if self.new_ver != 0:
            if self.cur_ver < self.new_ver or not self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe_is1', 'UninstallString'):
                self.log.info(u'Mise a jour declenchee')
                if self.restart:
                    self.gmessage =  "Une mise  jour est en cours, le systme va redmarrer automatiquement"
                    a = threads.deferToThread(self.mbox)
                self.inst_args = get_option(conf_f, 'global', 'inst_args')
                if not self.update(): return False
            else:
                self.log.info('Rien a faire ...')
            os.remove(self.conf_f)
            shutil.copy(conf_f, self.conf_f)
        else:
            self.log.info('Mise a jour du client desactivee (version = 0)')
        # purge du rpertoire temporaire
        try: shutil.rmtree(self.tmpdir)
        except: pass
        return True
                
    def uninstall_old(self):
        """dsinstallation de l'ancien paquet
        - par uninstall si le prcdent tait cliscribe-setup.exe (mode silencieux "/verysilent")
        - par l'ancienne mthode pour cliscribe V1
        """
        old = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe_is1', 'UninstallString')
        old_path = os.path.join(os.environ['windir'], 'Eole')
        path_updater = os.path.join(old_path, 'updater')
        # cas InnoSetup
        if old:
            self.log.info(u'Desinstallation de la version %s'%self.old_ver)
            cmd = '%s /VERYSILENT'%eval(old)
            self.log.info(cmd)
            ret = lancecmd(cmd)# /SUPPRESSMSGBOXES
            if ret != 0:
                self.log.error(u'Desinstallation echouee (code retour : %s)'%ret)
                return False
            time.sleep(2)
            self.RebootServer(bForce=1)
        # si le rpertoire existe mais sans l'updater
        elif os.path.isdir(old_path):
            up_uninstaller = self.get_reg_value('HKEY_LOCAL_MACHINE', r'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe-updater_is1', 'UninstallString')
            if not up_uninstaller:
                self.log.error('Erreur de registre "up_uninstaller"')
                return False
            up_uninstaller = eval(up_uninstaller)
            up_un_exe = os.path.split(up_uninstaller)[1]
            up_un_dat = '%s%s'%(os.path.splitext(up_un_exe)[0], '.dat')
            # liste des fichiers  NE PAS effacer
            exclude_list = [ up_un_dat, up_un_exe, 'tmp', 'updater', 'install.ini']
            self.log.info("Desinstallation de l'ancienne version.")
            if self.type_os == 'xp':
                netcmd = os.path.join(os.environ['WINDIR'], 'system32', 'net.exe')
                sccmd = os.path.join(os.environ['WINDIR'], 'system32', 'sc.exe')
                lancecmd('%s stop servscribe'%netcmd, hide=True)
                lancecmd('%s stop winvnc'%netcmd, hide=True)
                time.sleep(1)
                lancecmd('%s delete servscribe'%sccmd, hide=True)
                lancecmd('%s delete winvnc'%sccmd, hide=True)
            else:
                cmd = os.path.join(old_path, 'winvnc.exe')
                if os.path.isfile(cmd):
                    lancecmd('%s -kill'%cmd)#, hide=True)
                    time.sleep(1)
                    lancecmd('%s -remove'%cmd, nowait=True)#, hide=True)
            try:
                for i in os.listdir(old_path):
                    item = os.path.join(old_path, i)
                    if i not in exclude_list:
                        if os.path.isfile(item):
                            os.remove(item)
                        if os.path.isdir(item):
                            shutil.rmtree(item)
            except Exception, e:
                self.log.error('Desinstallation echouee : %s'%e)
                return False
        else:
            self.log.info('Rien a faire')
        return True
    
    def update(self):
        """tlcharge self.setup (inclue comparatif checksum)
        dsinstalle l'ancienne version
        installe la nouvelle
        """
        self.get_values()
        self.get_version()
        # tlchargement et vrification de l'archive
        if not self.download(self.setup):
            self.gmessage = "Le tlchargement a chou. Abandon de la mise  jour."
            a = threads.deferToThread(self.mbox)
            return False
        # dsinstallation
        if not self.uninstall_old(): 
            self.gmessage = "La dsinstallation de l'ancienne version a chou. Abandon de la mise  jour."
            a = threads.deferToThread(self.mbox)
            return False
        # installation de la nouvelle version
        self.log.info('Installation de la version %s'%self.new_ver)
        cmd = os.path.join(self.tmpdir, self.setup)
##        cmd_args = ' /SILENT /NORESTART'# /SUPPRESSMSGBOXES
##        cmd_args += ' /ip_scribe=%s'%self.serveur
##        cmd_args += ' /nom_scribe=%s'%self.nom_scribe
##        cmd_args += ' /port_scribe=%s'%self.port_scribe
##        cmd_args += ' /nom_domaine=%s'%self.nom_domaine
##        cmd_args += ' /port_client=%s'%self.port_client
        cmd_args = self.inst_args
        self.log.info(u'%s %s'%(cmd, cmd_args))
        ret = lancecmd('%s %s'%(cmd, cmd_args))
        if ret == 0: self.log.info(u'Mise a jour terminee')
        else:
            self.log.error(u'Mise a jour echouee : %s'%ret)
            return False
        if self.restart: self.RebootServer(bForce=1)
        return True
    
    ####################
    def mbox(self):
        gmessage(self.gmessage, "Mise  jour du client Scribe")

    def get_reg_value(self, key, path, name):
        """rcupre la valeur de
        key\path:name
        dans la Base De Registre
        """
        skey = getattr(_winreg, key)
        try:
            hkey = _winreg.OpenKey(skey, path)
            return _winreg.QueryValueEx(hkey, name)[0]
        except Exception, e:
            return None
        
    ####################
    ## tlchargement ##
    ####################
    def download(self, fich):
        """supprime le rpertoire self.tmpdir et le recre
        tlcharge "fich" et "fich.MD5SUM" et compare les checksums
        """
        try:
            if not os.path.exists(self.tmpdir):
                os.makedirs(self.tmpdir)
            return self.get_file(fich)
        except Exception, e:
            self.log.error(e)
            return False

    def get_file(self, fich):
        """tlcharge "fich" et "fich.MD5SUM" sur self.serveur
        calcul le checksum de fich et le compare  celui contenu dans "fich.MD5SUM"
        """
        dest = os.path.join(self.tmpdir, fich)
        dest5 = '%s.MD5SUM'%dest
        for i in [dest, dest5]:
            if os.path.exists(i):
                os.remove(i)
        url = 'http://%s:%s/%s'%(self.serveur, self.port, fich)
        url5 = '%s.MD5SUM'%url
        self.log.info(u'Telechargement de %s'%url)
        file(dest, 'wb').write(urllib2.urlopen(url).read())
        self.log.info(u'Telechargement de %s'%url5)
        file(dest5, 'wb').write(urllib2.urlopen(url5).read())
        if self.check_sum(dest, dest5): return dest
        else: return False
        
    def check_sum(self, fich, sumfich):
        """rcupre le checksum contenu dans sumfich,
        calcule le checksum de fich
        et compare les deux
        """
        orig_sum = file(sumfich, 'r').readlines()[0].strip().split()[0].strip()
        dest_sum = md5.md5(file(fich,'rb').read()).hexdigest().strip()
        if orig_sum == dest_sum:
            self.log.info('checksum OK %s'%orig_sum)
            return True
        else:
            self.log.error('orig MD5 : %s, dest MD5 : %s'%(orig_sum, dest_sum))
            return False

    #################
    ## redmarrage ##
    #################
    def AdjustPrivilege(self, enable = 1):
        """sous windows, redmarrer est un privilge ...
        """
        import win32security as wsec
        import ntsecuritycon as ntsec
        self.privileges = [ntsec.SE_BACKUP_NAME, ntsec.SE_SHUTDOWN_NAME]
        for priv in self.privileges:
            # Get the process token.
            flags = ntsec.TOKEN_ADJUST_PRIVILEGES | ntsec.TOKEN_QUERY
            htoken = wsec.OpenProcessToken(wa.GetCurrentProcess(), flags)
            # Get the ID for the system shutdown privilege.
            id = wsec.LookupPrivilegeValue(None, priv)
            # Now obtain the privilege for this process.
            # Create a list of the privileges to be added.
            if enable:
                newPrivileges = [(id, ntsec.SE_PRIVILEGE_ENABLED)]
            else:
                newPrivileges = [(id, 0)]
            # and make the adjustment.
            wsec.AdjustTokenPrivileges(htoken, 0, newPrivileges)

    def RebootServer(self, message="", timeout=0, bForce=0, bReboot=1):
        self.log.info('Redemarrage')
        if self.type_os == 'xp':
##            lancecmd('shutdown.exe -r -f -t 0', hide=True)
##            self.log.info('Oups')
            self.AdjustPrivilege()
            while True:
                try:
                    wa.InitiateSystemShutdown(None, message, timeout, bForce, bReboot)
                    break
                except: continue
                time.sleep(0.5)
        elif self.type_os == '9x':
            cmd = os.path.join(os.environ['WINDIR'], r'system\runonce.exe -q')
            wa.WinExec(cmd)
        reactor.stop()

    ############
    ## logger ##
    ############
    def set_logger(self):
        # on log sur 2 fichiers de 100ko   
        logfile = os.path.join(os.environ['WINDIR'], 'cliscribe_updater.log')
        handler = RotatingFileHandler(logfile,'a',100000,2)
        _formatter = logging.Formatter('%(asctime)s (%(process)d) %(levelname)s %(message)s')
        handler.setFormatter(_formatter)
        self.log = logging.getLogger(logfile)
        self.log.addHandler(handler)
        self.log.setLevel(logging.INFO)


    
def ret_update(ret=True):
    if ret:
        reactor.stop()
    else:
        reactor.stop()
        sys.exit(1)

def main():
    if '--norestart' in sys.argv[1:] or '-ns' in sys.argv[1:] : restart = False
    else: restart = True
    updt = upDater(restart)
    d = threads.deferToThread(updt.test_update)
    d.addCallback(ret_update)
    d.addErrback(ret_update)
    reactor.run()
    return

if __name__ == "__main__":
    main()


