#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_


##import wx
import getopt, sys

from twisted.internet import reactor
from cfgparse import ConfigParser

from gest_app import GestApp



### Affichage de MessageBox
##class GraphApp(wx.App):
##    def __init__(self, redirect=False, filename=None, useBestVisual=False, clearSigInt=True, message=None, titre=None):
##        self.message = message
##        self.titre = titre
##        wx.App.__init__(self, redirect, filename, useBestVisual, clearSigInt)
##
##    def OnInit(self):
##        wx.InitAllImageHandlers()
##        wx.MessageBox(self.message, self.titre)
##        return True

def get_pref(fich, pref):
    """lit le fichier des prfrences et retourne la valeur du paramtre
    """
    c = ConfigParser()
    c.add_file(fich)
    return c.add_option(pref).get().lower().strip()

# Fonctions de retour des deferreds
def return_lance(ret):
    reactor.stop()

def return_inst_app(ret, app):
    reactor.stop()
    if ret == 0: print '"%s" : installation termine'%app
    else: print '"%s" : installation echoue !'%app
##    if ret == 0: GraphApp(message='"%s" : installation termine'%app, titre='Installation')
##    else: GraphApp(message='"%s" : installation echoue !'%app, titre='Installation')

def return_err(ret, msg):
    reactor.stop()
    print '%s : %s'%(ret, msg)

def return_apps(apps):
    reactor.stop()
    if type(apps) != dict:
        print 'Erreur : %s'%apps
##        GraphApp(message='%s'%apps, titre='Erreur')
    if len(apps) > 0:
        m = ''
        for i in apps.keys():
            m += '%s : %s\n'%(i, apps[i]['titre'])
        print m
##        GraphApp(message=m, titre='Liste des applications')
    else:
        print 'Aucune application'

# Fonctions ligne de commande
def aide():
    return """Utilisation :

%(app)s => utilisation graphique

%(app)s -i (--install) id_application
%(app)s -l (--liste) liste les applications
%(app)s -h (--help) affiche ce message
"""%(dict(app = sys.argv[0]))

def main():
    prefs_f = 'app-install.ini'
    serveur = get_pref(prefs_f, 'serveur')
    port = int(get_pref(prefs_f, 'port'))

    app = None
    liste = False

    try:
        options, args = getopt.getopt(sys.argv[1:],'i:d:lh',
        ['install=',
        'demarre=',
        'liste',
        'help'])

    except getopt.GetoptError:
        er_type, er_value, er_traceback = sys.exc_info()
        er_msg = str(er_value)
        sys.exit("""L'option "-%s" est inconnue ou necessite un argument""" % er_msg[er_msg.index('-')+1])

    for (opt,val) in options:
        if (opt == '-i') or (opt == '--install'):
            app = val
            gest = GestApp(serveur, port)
            gest.inst_app(app, return_inst_app, return_err)
            reactor.run()
        elif (opt == '-l') or (opt == '--liste'):
            gest = GestApp(serveur, port)
            gest.get_apps(return_apps, return_err)
            reactor.run()
        elif (opt == '-d') or (opt == '--demarre'):
            gest = GestApp(serveur, port)
            gest.lance_app(return_lance, return_err)
            reactor.run()
        elif (opt == '-h') or (opt == '--help'):
            sys.exit(aide())
##            GraphApp(message = aide(), titre = 'Aide')
        
if __name__ == '__main__':
    main()
